package common.worldgen;

import common.rng.Random;
import common.util.BlockPos;
import common.world.State;
import common.world.AWorldServer;

public abstract class FeatureGenerator
{
    private final boolean doBlockNotify;

    public FeatureGenerator()
    {
        this(false);
    }

    public FeatureGenerator(boolean notify)
    {
        this.doBlockNotify = notify;
    }

    public abstract boolean generate(AWorldServer worldIn, Random rand, BlockPos position);

    protected void setBlockAndNotifyAdequately(AWorldServer worldIn, BlockPos pos, State state)
    {
        if (this.doBlockNotify)
        {
            worldIn.setState(pos, state, 3);
        }
        else
        {
            worldIn.setState(pos, state, 2);
        }
    }
}
